import {onBeforeUnmount,onMounted,ref} from "vue";
import {editLoginState} from "@/service/login";
import {updateLoginLasttime} from "@/service/login";
import router from "@/router/index";
import {useRootStore} from "@/pinia/useStore";
import {showMessage} from "@/units/element-ui/tip";


export function UseChangeOperationTime(){

    const store = useRootStore()
    const timer = ref(null)
    const timeout = ref(null)
    const outTimer = ref(null)
    const myTimer = ref( 900 )
    function fn () {
        clearInterval(timer.value)
        timer.value = setTimeout(() => {
            updateLoginLasttime().then(res => {

            })
            fn();
        }, 3000);
    }
    fn();
    function exitFun (){
        showMessage({
            tpe:'warning',
            message:'超时未操作,已退出'
        })

        router.push('/login')
        editLoginState(store.userInfo.xyxx_userkeycode,store.userInfo.xyxx_userkeycode,'0').then(res => {


            store.userInfo = {}
            localStorage.removeItem('loginUserInfo')
        })

    }
    function moveEvent(){

        clearTimeout(timeout.value)

        timeout.value = setTimeout(exitFun,900000)
        clearInterval(outTimer.value)
        myTimer.value =  900


        outTimer.value = setInterval(() => {

            myTimer.value = myTimer.value - 1
        },1000)
    }
    clearTimeout(timeout.value)
    timeout.value = setTimeout(exitFun,900000)
    clearInterval(outTimer.value)

    outTimer.value = setInterval(() => {
        myTimer.value = myTimer.value - 1
    },1000)
    onMounted(() => {
        document.body.removeEventListener('mousemove',moveEvent)
        document.body.addEventListener('mousemove',moveEvent)
    })

    onBeforeUnmount(() => {

        clearInterval(timer.value)
        clearTimeout(timeout.value)
        clearInterval(outTimer.value)
        document.body.removeEventListener('mousemove',moveEvent)
    })
    return {
        myTimer
    }
}
