import { ElLoading } from 'element-plus'
import {nextTick} from "vue";

let loadingInstance = null;
export function showLoading(options){
    let op = {
        target:'.mmm'
    }
    if(loadingInstance !==null){
        loadingInstance.close();
        loadingInstance = null;
    }
    loadingInstance  = ElLoading.service({
        ...op,
        ...options
    })

}
export function closeShowLoading() {
    nextTick(() => {
        loadingInstance.close();
        loadingInstance = null;
    })
}
